



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>记录下Webapi签名机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">记录下Webapi签名机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 09:30:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　首先，写这篇文章的原因是因为最近某一个项目中的接口被人为调用了，导致了数据库数据被串改。虽然是内部人无意点的，但还是引起了我的担忧，所有整理了下关于Webapi的相关签名机制。</p>
<p>一、我们在开发接口时，有时候嫌麻烦就懒进行相关的验证或只进行一些简单的验证,这样客户端就可以直接调用：如</p>
<p>调用Webapi接口：http://XXX.XXX.XX.XXX:8123/Token/GetTest?ID=123456</p>
<p>这种方式简单粗暴，在浏览器直接输入"http://XXX.XXX.XX.XXX:8123/Token/GetTest?ID=123456"，即可获取产品列表信息了，但是这样的方式会存在很严重的安全性问题，没有进行任何的验证，大家都可以通过这个方法获取到产品列表，导致产品信息泄露，下面简单记录下使用使用TOKEN+签名认证</p>
<p>二、<strong>使用TOKEN+签名认证 保证请求安全性</strong></p>
<p>　　token+签名认证的主要原理是：1.做一个认证服务，提供一个认证的webapi，用户先访问它获取对应的token</p>
<p>2.用户拿着相应的token以及请求的参数和服务器端提供的签名算法计算出签名后再去访问指定的api</p>
<p>　　　　　　　　　　　　　　3.服务器端每次接收到请求就获取对应用户的token和请求参数，服务器端再次计算签名和客户端签名做对比，如果验证通过则正常访问相应的api，验证失败则 返回具体的失败信息</p>
<p>具体代码如下：</p>
<p>1.用户请求认证服务GetToken，将token保存在服务器端缓存中，并返回对应的Token到客户端（该请求不需要进行签名认证）,使用GET调用方式</p>
<div>
<pre class="prettyprint linenums">[HttpGet]<br />
public IHttpActionResult GetToken(string signKey)<br />
{<br />
    if (string.IsNullOrEmpty(signKey))<br />
        return Json&lt;ResultMsg&gt;(new ResultMsg((int)ExceptionStatus.ParameterError, EnumExtension.GetEnumText(ExceptionStatus.ParameterError), null));<br />
    //根据签名ID获取缓存token<br />
    string strKey = string.Format("{0}{1}", WebConfig.signKey, signKey);<br />
    Token cacheData = HttpRuntime.Cache.Get(strKey) as Token;<br />
    if (cacheData == null)<br />
    {<br />
        cacheData = new Token();<br />
        cacheData.signId = signKey;<br />
        cacheData.timespan = DateTime.Now.AddDays();<br />
        cacheData.signToken = Guid.NewGuid().ToString("N");<br />
        //插入缓存，缓存时间为1天<br />
        HttpRuntime.Cache.Insert(strKey, cacheData, null, cacheData.timespan, TimeSpan.Zero);<br />
    }<br />
       //返回token信息<br />
        return Json&lt;ResultMsg&gt;(new ResultMsg((int)ExceptionStatus.OK, EnumExtension.GetEnumText(ExceptionStatus.OK), cacheData));<br />
}</pre>
</div>
<p>2.客户端调用方法，GET或POST</p>
<p>(1) GET:需要在请求头中添加：timespan（时间戳），nonce（随机数），signKey（key），signature（签名参数）</p>
<div>
<pre class="prettyprint linenums"> 　　　　public static T Get&lt;T&gt;(string url, string paras, string signId,bool isSign=true)<br />
        {<br />
            HttpWebRequest webrequest = null;<br />
            HttpWebResponse webresponse = null;<br />
            string strResult = string.Empty;<br />
            try<br />
            {<br />
                webrequest = (HttpWebRequest)WebRequest.Create(url + "?" + paras);<br />
                webrequest.Method = "GET";<br />
                webrequest.ContentType = "application/json";<br />
                webrequest.Timeout = ;<br />
                //加入头信息<br />
                string timespan = GetTimespan();<br />
                string ran = GetRandom();<br />
                webrequest.Headers.Add("signKey", signId);<br />
                DbLogger.LogWriteMessage("signKey:" + signId);<br />
                webrequest.Headers.Add("timespan", timespan);<br />
                DbLogger.LogWriteMessage("timespan:" + timespan);<br />
                webrequest.Headers.Add("nonce", ran);<br />
                DbLogger.LogWriteMessage("nonce:" + ran);<br />
                if (isSign)<br />
                {<br />
                    string strSign = GetSignature(signId, timespan, ran, paras);<br />
                    webrequest.Headers.Add("signature", strSign);<br />
                    DbLogger.LogWriteMessage("signature:" + strSign);<br />
                }<br />
                webresponse = (HttpWebResponse)webrequest.GetResponse();<br />
                Stream stream = webresponse.GetResponseStream();<br />
                StreamReader sr = new StreamReader(stream, Encoding.UTF8);<br />
                strResult = sr.ReadToEnd();<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                return JsonConvert.DeserializeObject&lt;T&gt;(ex.Message);<br />
            }<br />
            finally<br />
            {<br />
                if (webresponse != null)<br />
                    webresponse.Close();<br />
                if (webrequest != null)<br />
                    webrequest.Abort();<br />
            }<br />
            return JsonConvert.DeserializeObject&lt;T&gt;(strResult);<br />
        }</pre>
</div>
<p>(2)POST写法这里就不写了，同理需要设置header请求头参数：timespan（时间戳），nonce（随机数），signKey（key），signature（签名参数）</p>
<p>(3)根据请求参数计算本次请求的签名，用timespan+nonc+signKey+token+data（请求参数字符串）得到signStr签名字符串，然后再进行排序和MD5加密得到最终的signature签名字符串，添加到请求头中</p>
<div>
<pre class="prettyprint linenums">　　　　 public static string GetSignature(string signKey, string timespan, string nonce, string data)<br />
        {<br />
            string signToken = string.Empty;<br />
            var result = GetToken&lt;JObject&gt;();<br />
            if (result != null)<br />
            {<br />
                if (result["code"].ToString() == "")<br />
                {<br />
                    var tokena = JsonConvert.DeserializeObject&lt;JObject&gt;(result["result"].ToString());<br />
                    if (tokena != null)<br />
                        signToken = tokena["signToken"].ToString();<br />
                }<br />
            }

            var hash = MD5.Create();<br />
            string str = signKey + timespan + nonce + signToken + data;<br />
            byte[] bytes = Encoding.UTF8.GetBytes(string.Concat(str.OrderBy(c =&gt; c)));<br />
            DbLogger.LogWriteMessage("str内容:" + string.Concat(str.OrderBy(c =&gt; c)));<br />
            //使用MD5加密<br />
            var md5Val = hash.ComputeHash(bytes);<br />
            //把二进制转化为大写的十六进制<br />
            StringBuilder strSign = new StringBuilder();<br />
            foreach (var val in md5Val)<br />
            {<br />
                strSign.Append(val.ToString("X2"));<br />
            }<br />
            return strSign.ToString();<br />
        }</pre>
</div>
<p>(4)Webapi接收到相应参数，通过header获取到timespan（时间戳），nonce（随机数），signKey（key），signature（签名参数），判断参数是否为空、接口是否在有效时间内、判断token是否有效、判断和请求的signature(签名)是否相同，如果通过，返回正常的结果。如果验证不通过，返回相应的错误提示信息。</p>
<div>
<pre class="prettyprint linenums">　　　　 public override void OnActionExecuting(System.Web.Http.Controllers.HttpActionContext filterContext)<br />
        {<br />
            ResultMsg result = null;<br />
            string signKey = string.Empty, timespan = string.Empty, nonce = string.Empty, signature = string.Empty;<br />
            //判断请求的消息中是否包括判断参数<br />
            var request = filterContext.Request;<br />
            if (request.Headers.Contains("signKey"))<br />
                signKey = request.Headers.GetValues("signKey").FirstOrDefault();<br />
            if (request.Headers.Contains("timespan"))<br />
                timespan = request.Headers.GetValues("timespan").FirstOrDefault();<br />
            if (request.Headers.Contains("nonce"))<br />
                nonce = request.Headers.GetValues("nonce").FirstOrDefault();<br />
            if (request.Headers.Contains("signature"))<br />
                signature = request.Headers.GetValues("signature").FirstOrDefault();

            //如果方法是GetToken,则不需要验证<br />
            if (filterContext.ActionDescriptor.ActionName.ToLower() == "gettoken")<br />
            {<br />
                if (string.IsNullOrEmpty(signKey) || string.IsNullOrEmpty(timespan) || string.IsNullOrEmpty(nonce))<br />
                {<br />
                    result = new ResultMsg((int)ExceptionStatus.ParameterError, EnumExtension.GetEnumText(ExceptionStatus.ParameterError), null);<br />
                    filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                    base.OnActionExecuting(filterContext);<br />
                    return;<br />
                }<br />
                else<br />
                {<br />
                    base.OnActionExecuting(filterContext);<br />
                    return;<br />
                }<br />
            }<br />
            DbLogger.LogWriteMessage("测试参数");<br />
            string signtoken = string.Empty;<br />
            //判断是否包含以下参数<br />
            if (string.IsNullOrEmpty(signKey) || string.IsNullOrEmpty(timespan) || string.IsNullOrEmpty(nonce) || string.IsNullOrEmpty(signature))<br />
            {<br />
                result = new ResultMsg((int)ExceptionStatus.ParameterError, EnumExtension.GetEnumText(ExceptionStatus.ParameterError), null);<br />
                filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                base.OnActionExecuting(filterContext);<br />
                return;<br />
            }

            DbLogger.LogWriteMessage("测试是否在有效时间内");<br />
            //判断是否在有效时间内<br />
            double ts1 = ;<br />
            double ts2 = (DateTime.UtcNow - new DateTime(, , , , , )).TotalMilliseconds;<br />
            bool timespanValidate = double.TryParse(timespan, out ts1);<br />
            double ts = ts2 - ts1;<br />
            bool falg = ts &gt; int.Parse(WebConfig.UrlExpireTime) * ;<br />
            if (!timespanValidate || falg)<br />
            {<br />
                result = new ResultMsg((int)ExceptionStatus.URLExpireError, EnumExtension.GetEnumText(ExceptionStatus.URLExpireError), null);<br />
                filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                base.OnActionExecuting(filterContext);<br />
                return;<br />
            }

            DbLogger.LogWriteMessage("测试token是否有效");<br />
            //判断token是否有效<br />
            Token token = HttpRuntime.Cache.Get(string.Format("{0}{1}", WebConfig.signKey, signKey)) as Token;<br />
            if (token == null)<br />
            {<br />
                result = new ResultMsg((int)ExceptionStatus.TokenInvalid, EnumExtension.GetEnumText(ExceptionStatus.TokenInvalid), null);<br />
                filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                base.OnActionExecuting(filterContext);<br />
                return;<br />
            }<br />
            else<br />
                signtoken = token.signToken;

            DbLogger.LogWriteMessage("判断http调用方式");<br />
            string data = string.Empty;<br />
            //判断http调用方式<br />
            string method = request.Method.Method.ToUpper();<br />
            switch (method)<br />
            {<br />
                case "POST":<br />
                    Stream stream = HttpContext.Current.Request.InputStream;<br />
                    string responseJson = string.Empty;<br />
                    StreamReader streamReader = new StreamReader(stream);<br />
                    data = streamReader.ReadToEnd();<br />
                    break;<br />
                case "GET":<br />
                    NameValueCollection form = HttpContext.Current.Request.QueryString;<br />
                    //第一步：取出所有get参数<br />
                    IDictionary&lt;string, string&gt; parameters = new Dictionary&lt;string, string&gt;();<br />
                    for (int f = ; f &lt; form.Count; f++)<br />
                    {<br />
                        string key = form.Keys[f];<br />
                        parameters.Add(key, form[key]);<br />
                    }

                    // 第二步：把字典按Key的字母顺序排序<br />
                    IDictionary&lt;string, string&gt; sortedParams = new SortedDictionary&lt;string, string&gt;(parameters);<br />
                    IEnumerator&lt;KeyValuePair&lt;string, string&gt;&gt; dem = sortedParams.GetEnumerator();

                    // 第三步：把所有参数名和参数值串在一起<br />
                    StringBuilder query = new StringBuilder();<br />
                    while (dem.MoveNext())<br />
                    {<br />
                        string key = dem.Current.Key;<br />
                        string value = dem.Current.Value;<br />
                        if (!string.IsNullOrEmpty(key))<br />
                        {<br />
                            query.Append(key).Append(value);<br />
                        }<br />
                    }<br />
                    data = query.ToString();<br />
                    break;<br />
                default:<br />
                    result = new ResultMsg((int)ExceptionStatus.HttpMehtodError, EnumExtension.GetEnumText(ExceptionStatus.HttpMehtodError), null);<br />
                    filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                    base.OnActionExecuting(filterContext);<br />
                    break;<br />
            }

            DbLogger.LogWriteMessage("验证签名信息是否符合");<br />
            //验证签名信息是否符合<br />
            bool valida = ValidateSign.Validate(signKey, timespan, nonce, signtoken, data, signature);<br />
            if (!valida)<br />
            {<br />
                result = new ResultMsg((int)ExceptionStatus.HttpRequestError, EnumExtension.GetEnumText(ExceptionStatus.HttpRequestError), null);<br />
                filterContext.Response = HttpResponseExtension.ToJson(result);<br />
                base.OnActionExecuting(filterContext);<br />
                return;<br />
            }<br />
            else<br />
                base.OnActionExecuting(filterContext);<br />
        }<br />
    }</pre>
</div>
<p><strong>下面我们进行测试：</strong></p>
<p><strong>GET请求：</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/835511/201711/835511-20171106115301700-1938600316.png" /></strong></p>
<p>返回结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/835511/201711/835511-20171106115455231-286011449.png" /></p>
<p>但我们在浏览器中直接显示或信息被串改时，不合法的请求就会被识别为请求参数已被修改</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/835511/201711/835511-20171106115646044-585195216.png" /></p>
<p>判断签名是否成功，第一次请求签名参数signature和服务器端计算result完全相同， 然后当把请求参数修改之后服务器端计算的result和请求签名参数signature不同，所以请求不合法，是非法请求，同理如果其他任何参数被修改最后计算的结果都会和签名参数不同，请求同样识别为不合法请求</p>
<p><strong>总结：</strong></p>
<p>通过上面的案例，我们可以看出，安全的关键在于参与签名的token，整个过程中token是不参与通信的，所以只要保证token不泄露，请求就不会被伪造。</p>
<p>然后我们通过timestamp时间戳用来验证请求是否过期，这样就算被人拿走完整的请求链接也是无效的。</p>
<p><strong>源码下载地址</strong>：https://pan.baidu.com/s/1hrBOnRY</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1vnzqg.html">在知乎上看到 Web Socket这篇文章讲得确实挺好，从头看到尾都非常形象生动，一口气看完，没有半点模糊，非常不错</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4pdy0q.html">执行shell脚本，报错坏的解释器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oyexj9.html">R语言字符串函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdke548.html">sql语句常见错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2ryn9.html">多线程下的performSelector和NSThread的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k50249.html">关于tomcat启动没有进行编译或者编译报错的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoj3r3q.html">WeMall微信商城源码活动报名插件代码详情</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn3y19.html">cuda编程学习3&mdash;&mdash;VectorSum</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2dv08.html">11、借助POI实现Java生成并打印excel报表&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95044768.html">基本数据对象（int&comma;float&comma;str）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7wjy8.html">eclipse maven工程打包失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w74yzq.html">51Nod 1185 威佐夫游戏 V2</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r4ryo9.html">sublim 配置 用户默认绑定的格式化文本快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j152k09.html">1126 Eulerian Path （25 分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q257y3lq.html">C&num;--用户密码处理------混淆密码加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv77my8.html">python下以api形式调用tesseract识别图片验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko1mm3q.html">k8s如何管理Pod&lpar;rc、rs、deployment&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmrkjl9.html">WCF transport-and-message-security</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4dwor8.html">php mysql 字符集&lpar;三&rpar; &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5pmyx9.html">HTML-JavaScript的DOM操作-非重点部分</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qljwrn69.html">翻译连载 &vert; 第 9 章：递归（上）－《JavaScript轻量级函数式编程》 &vert;《你不知道的JS》姊妹篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgz3o8.html">ESC&sol;POS打印控制命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy16kymq.html">为什么Java中的String类是不可变的&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk67nd8.html">vector 向量容器用法祥解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzv5248.html">Linux脚本入门（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgpp38.html">分布式系统中生成全局ID的总结与思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1j4xjq.html">NodeJS中的事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/950z6lv8.html">php基础运算符语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgrgk8.html">苹果手机使用替代onkeyup的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z2p3e9.html">MongoDB学习教程（3）-常用命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
